"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useMetricWidgetContext = exports.MetricWidgetProvider = void 0;
var React = require("react");
var react_1 = require("@theia/core/shared/react");
var constants_1 = require("../constants");
var MetricWidgetContext = react_1.createContext({});
function MetricWidgetProvider(_a) {
    var _this = this;
    var children = _a.children, responseFormat = _a.responseFormat, metricUrl = _a.metricUrl;
    var _b = __read(react_1.useState(), 2), globalResponse = _b[0], setGlobalResponse = _b[1];
    var _c = __read(react_1.useState(), 2), globalResponseFormat = _c[0], setGlobalResponseFormat = _c[1];
    var _d = __read(react_1.useState({}), 2), responseDict = _d[0], setResponseDict = _d[1];
    react_1.useEffect(function () {
        fetchMetricUrl(metricUrl, responseFormat, true);
    }, []);
    var fetchMetricUrl = function (url, responseFormat, isGlobal) { return __awaiter(_this, void 0, void 0, function () {
        var response, data_1, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!url) return [3 /*break*/, 8];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 7, , 8]);
                    return [4 /*yield*/, fetch(url)];
                case 2:
                    response = _a.sent();
                    if (!(responseFormat === constants_1.EResponseFormat.PROMETHEUS)) return [3 /*break*/, 4];
                    return [4 /*yield*/, response.text()];
                case 3:
                    data_1 = _a.sent();
                    return [3 /*break*/, 6];
                case 4:
                    if (!(responseFormat === constants_1.EResponseFormat.JSON)) return [3 /*break*/, 6];
                    return [4 /*yield*/, response.json()];
                case 5:
                    data_1 = _a.sent();
                    _a.label = 6;
                case 6:
                    if (isGlobal) {
                        setGlobalResponse(data_1);
                        setGlobalResponseFormat(responseFormat);
                    }
                    else {
                        setResponseDict(function (prevState) {
                            var _a;
                            return (__assign(__assign({}, prevState), (_a = {}, _a[url] = { data: data_1 }, _a)));
                        });
                    }
                    return [3 /*break*/, 8];
                case 7:
                    err_1 = _a.sent();
                    console.error(err_1);
                    return [3 /*break*/, 8];
                case 8: return [2 /*return*/];
            }
        });
    }); };
    var getValueByKey = function (options) {
        var responseFormat = options.responseFormat;
        var value;
        var responseFormatTemp;
        responseFormatTemp = responseFormat || globalResponseFormat;
        if (responseFormatTemp === constants_1.EResponseFormat.PROMETHEUS) {
            value = getValueFromPrometheus(options);
        }
        else if (responseFormatTemp === constants_1.EResponseFormat.JSON) {
            value = getValueFromJson(options);
        }
        return value;
    };
    var getValueFromPrometheus = function (options) {
        var _a;
        var key = options.key, metricUrl = options.metricUrl;
        var source;
        if (metricUrl) {
            source = (_a = responseDict[metricUrl]) === null || _a === void 0 ? void 0 : _a.data;
        }
        else {
            source = globalResponse;
        }
        var dataArr = source.split("\n");
        var line = dataArr.find(function (e) { return e.startsWith(key); });
        if (!line) {
            return "";
        }
        var lineArr = line.split(" ");
        return lineArr[lineArr.length - 1];
    };
    var getValueFromJson = function (options) {
        var _a;
        var key = options.key, metricUrl = options.metricUrl, keySeparator = options.keySeparator;
        var source;
        if (metricUrl) {
            source = (_a = responseDict[metricUrl]) === null || _a === void 0 ? void 0 : _a.data;
        }
        else {
            source = globalResponse;
        }
        var value = source;
        if (value) {
            if (keySeparator) {
                var keyArr = key.split(keySeparator);
                keyArr.forEach(function (el) { return (value = value ? value[el] : ""); });
            }
            else {
                value = source[key];
            }
        }
        return value;
    };
    var initialState = {
        globalResponse: globalResponse,
        globalResponseFormat: globalResponseFormat,
        responseDict: responseDict,
        fetchMetricUrl: fetchMetricUrl,
        getValueByKey: getValueByKey,
    };
    return (React.createElement(MetricWidgetContext.Provider, { value: initialState }, children));
}
exports.MetricWidgetProvider = MetricWidgetProvider;
var useMetricWidgetContext = function () { return react_1.useContext(MetricWidgetContext); };
exports.useMetricWidgetContext = useMetricWidgetContext;
//# sourceMappingURL=MetricWidgetContext.js.map