import { EResponseFormat } from "../constants";

export interface IMetricWidgetContext {
  globalResponse: any;
  globalResponseFormat?: EResponseFormat;
  responseDict: IResponseDict;
  fetchMetricUrl: (
    url?: string,
    responseFormat?: EResponseFormat,
    isGlobal?: boolean
  ) => void;
  getValueByKey: (options: IGetValueOptions) => any;
}
export interface IMetricWidgetProvider {
  children: React.ReactNode;
  metricUrl: string;
  responseFormat: EResponseFormat;
}

export interface IResponseDict {
  [url: string]: IResponse;
}

export interface IResponse {
  data: any;
}

export interface IGetValueOptions {
  key: string;
  keySeparator?: string;
  metricUrl?: string;
  responseFormat?: EResponseFormat;
}
