import * as React from "react";
import { createUseStyles } from "react-jss";
import { IMetricWidget } from "../../constants";

const useStyles = createUseStyles({
  container: {
    display: "grid",
    gridTemplateColumns: "repeat(auto-fill, 302px)",
    gridGap: 24,
    marginBottom: 36,
  },
  subTitle: {
    color: "var(--theia-descriptionForeground)",
    fontSize: 24,
    margin: "0 0 24px 0",
  },
});
interface ISingleValueContainerProps {
  widget: IMetricWidget;
  children: React.ReactNode;
}
const SingleValueContainer = (props: ISingleValueContainerProps) => {
  const { widget, children } = props;
  const classes = useStyles();

  return (
    <>
      <h3 className={classes.subTitle}>{widget.title}</h3>
      <div className={classes.container}>{children}</div>
    </>
  );
};

export default SingleValueContainer;
