export enum EResponseFormat {
  JSON = "json",
  PROMETHEUS = "prometheus",
}

export enum EMetricWidgetType {
  SINGLE_VALUE = "single_value",
  SINGLE_VALUE_CONTAINER = "single_value_container",
  BAR_CHART = "bar_chart",
}

export interface IChartLegend {
  key: string;
  label: string;
  color: string;
}

export interface IMetricWidget {
  title: string;
  value_key: string;
  key_separator?: string;
  widgets?: IMetricWidget[];
  type: EMetricWidgetType;
  description_key?: string;
  unit?: string;
  description?: string;
  metric_url?: string;
  response_format?: EResponseFormat;
  value_keys?: string[];
  x_axis_label?: string;
  y_axis_label?: string;
  legend?: IChartLegend[];
  fallback_value?: string;
}
